<template>
  <section>
    <aside class="fix-sidebar left-sidebar card-no-border">
      <!-- Sidebar scroll-->
      <div class="scroll-sidebar">
        <!-- User profile -->
        
        <nav class="sidebar-nav">
          <ul class="metismenu" id="sidebarnav">
            <li class="nav-small-cap">ADMINISTRAR</li>
            <!-- FUNCIONES ROL PROFESOR -->
            <li v-show="user.nombreRol  === 'DOCENTE'">
              <router-link :to="{ name: 'paseLista' }" active-class="active">
                <i class="material-icons">person</i>
                <span class="hide-menu">Pasar lista</span>
              </router-link>
            </li>
            <li v-show="user.nombreRol  === 'DOCENTE'">
              <router-link :to="{ name: 'subirCalificaciones' }" active-class="active">
                <i class="material-icons">file_copy</i>
                <span class="hide-menu">Subir calificaciones</span>
              </router-link>
            </li>

            <!-- FUNCIONES ROL ASPIRANTE -->
            <li v-show="user.nombreRol  === 'ASPIRANTE'">
              <router-link :to="{ name: 'HistorialAcademico' }">
                <i class="material-icons">school</i>
                <span class="hide-menu">Historial academico</span>
              </router-link>
            </li>
            <li v-show="user.nombreRol  === 'ASPIRANTE'">
              <router-link :to="{ name: 'EvaluacionDocente' }">
                <i class="material-icons">assignment_turned_in</i>
                <span class="hide-menu">Evaluación docente</span>
              </router-link>
            </li>

            <!-- FUNCIONES ROL SERVICIOS ESCOLARES -->
            <li v-show="user.nombreRol  === 'SERVICIOS'">
              <router-link :to="{ name: 'AsignacionGrupos' }">
                <i class="material-icons">assignment</i>
                <span class="hide-menu">Asignación de grupos</span>
              </router-link>
            </li>
            <li v-show="user.nombreRol  === 'SERVICIOS'">
              <router-link :to="{ name: 'PreguntasEvaluacion' }">
                <i class="material-icons">assignment_turned_in</i>
                <span class="hide-menu">Gestión evaluación docente</span>
              </router-link>
            </li>
            <li v-show="user.nombreRol  === 'SERVICIOS'">
              <router-link :to="{ name: 'AsignacionAspirantes' }">
                <i class="material-icons">school</i>
                <span class="hide-menu">Asginación aspirantes</span>
              </router-link>
            </li>

            <!-- DIRECTOR DE CARRERA -->
            <li v-show="user.nombreRol  === 'DIRECTOR'">
              <router-link :to="{ name: 'docentes' }">
                <i class="material-icons">people_alt</i>
                <span class="hide-menu">Gestión de docentes</span>
              </router-link>
            </li>
            <li v-show="user.nombreRol  === 'DIRECTOR'">
              <router-link :to="{ name: 'AsignacionMaterias' }">
                <i class="material-icons">book</i>
                <span class="hide-menu">Asignación de materias</span>
              </router-link>
            </li>

            <!-- ADMINISTRADOR -->
            <li v-show="user.nombreRol === 'ADMIN'">
              <router-link :to="{ name: 'Directores' }">
                <i class="material-icons">people</i>
                <span class="hide-menu">Directores</span>
              </router-link>
            </li>
            <li v-show="user.nombreRol  === 'ADMIN'">
              <router-link :to="{ name: 'divisionesCarreras' }">
                <i class="material-icons">ballot</i>
                <span class="hide-menu">Divisiones y carrreras</span>
              </router-link>
            </li>
            <li>
              <a @click="destruirSesion()">
                <i class="material-icons">power_settings_new</i>
                <span class="hide-menu">Cerrar sesión</span>
              </a>
            </li>

            <!-- <li>
              <a href="#" data-toggle="modal" data-target="#exampleModal">
                <i class="material-icons">notifications</i>
                <span class="hide-menu">Notificaciones</span>
              </a>
            </li>
            <li>
              <a href="#" data-toggle="modal" data-target="#exampleModal">
                <i class="material-icons">error</i>
                <span class="hide-menu">Reportar falla</span>
              </a>
            </li> -->
          </ul>
        </nav>
        <!-- End Sidebar navigation -->
      </div>
      <!-- End Bottom points-->
    </aside>
    <!--Modal Reportar Falla-->
    <div
      class="modal fade"
      id="exampleModal"
      tabindex="-1"
      role="dialog"
      aria-labelledby="exampleModalLabel"
      aria-hidden="true"
    >
      <div class="modal-dialog" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="exampleModalLabel">Reporte de falla</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body">
            <div class="form-group">
              <label for>Comentario:</label>
              <textarea class="form-control" name id cols="30" rows="5"></textarea>
            </div>
            <input type="file" @change="previewImage" accept="image/*"/>
            <div>
              <p v-show="uploadValue>0">
                Progress: {{uploadValue.toFixed()+"%"}}
                <progress
                  id="progress"
                  :value="uploadValue"
                  max="100"
                ></progress>
              </p>
            </div>
            <div v-if="imageData!=null">
              <img class="preview img-fluid" :src="picture" />
              <br />
            </div>
            <button type="button" class="btn btn-success" @click="onUpload">Cargar Imagen</button>
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-dismiss="modal">Cerrar</button>
            <button type="button" class="btn btn-warning" >Reportar Falla</button>
          </div>
        </div>
      </div>
    </div>
    <!--Final Modal Reportar Falla -->
  </section>
</template>

<script>
import firebase from "firebase";

export default {
  name: "Sidebar",
  data() {
    return {
      imageData: null,
      picture: null,
      uploadValue: 0,
      txtArea: null,
      user:[]
      
    };
  },
  mounted(){
        if(localStorage.getItem('usuario')){
          this.user = JSON.parse(localStorage.getItem('usuario'));
        }
  },
  methods: {
    destruirSesion(){
      localStorage.clear();
      this.$router.push("/login");
    },
    previewImage(event) {
      this.uploadValue = 0;
      this.picture = null;
      this.imageData = event.target.files[0];
    },

    onUpload() {
      this.picture = null;
      const storageRef = firebase
        .storage()
        .ref(`${this.imageData.name}`)
        .put(this.imageData);
      storageRef.on(
        `state_changed`,
        snapshot => {
          this.uploadValue =
            (snapshot.bytesTransferred / snapshot.totalBytes) * 100;
        },
        error => {
          console.log(error.message);
        },
        () => {
          this.uploadValue = 100;
          storageRef.snapshot.ref.getDownloadURL().then(url => {
            this.picture = url;
          });
        }
      );
    }
  }
};
</script>


<style scoped>
.smooth-enter-active,
.smooth-leave-active {
  transition: height 0.1s;
  overflow: hidden;
}
.smooth-enter,
.smooth-leave-to {
  height: 0;
}
.mini-sidebar .sidebar-nav {
  background: transparent !important;
}
.mini-sidebar .sidebar-nav ul li.active {
  background: transparent !important;
}
.router-link-exact-active.active {
  font-weight: bold;
}
.card-no-border .left-sidebar,
.card-no-border .sidebar-nav {
  background: #019979;
}
.left-sidebar {
  background: #019979;
  box-shadow: 1px 0px 20px rgba(0, 0, 0, 0.08) !important;
}
.sidebar-nav ul li.nav-small-cap {
  color: #fff;
}
.sidebar-nav > ul > li > a i {
  color: #fff;
}
.sidebar-nav ul li a {
  color: #fff;
}
.user-profile .profile-text {
  color: #000;
}
.sidebar-nav > ul > li > a:hover {
  border-left: 3px solid #fff;
}
.sidebar-nav > ul > li.active > a {
  border-left: 3px solid #fff;
  color: #fff;
  font-weight: bold;
}
.user-profile {
  text-align: center;
  position: relative;
  background: #fff;
  margin-top: -25px;
  padding-top: 30px;
}
.sidebar-nav .has-arrow::after {
  border-color: #fff;
}
.mini-sidebar .sidebar-nav #sidebarnav > li > ul {
  background: #3535359e;
}
.mini-sidebar .sidebar-nav #sidebarnav > li:hover > a {
  background: #3535359e;
  color: #ffffff;
  border-color: #fff;
}
.sidebar-nav ul li.active {
  background: #019979 !important;
}
.card-no-border .sidebar-nav > ul > li > a.active {
  background: #019979 !important;
}
</style>